#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <errno.h>
#include <ctype.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <pthread.h>
#include <sys/socket.h>
#include <sys/param.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/sem.h>
#include <sys/ipc.h>
#include "bluetooth/bluetooth.h"
#include "bluetooth/hci.h"
#include "bluetooth/hci_lib.h"
#include "bluetooth/sdp.h"
#include "bluetooth/sdp_lib.h"

#include "btconstants.h"
#include "btfunctions.h"

int main(int argc, char **argv) 
{
	int						devices_avail = 0, devices_ok=0, sock=0;
	mydevices_t				*mydevs=NULL,*mycurdev=NULL;
	founddevices_t			push_device;
	device_t				*device;
	bdaddr_t				*addr_num=NULL;
	
	if (argc < 4) {
		printf("Usage: bbt-push <bdaddr> <channel> <file> <mime>\n");
		exit(0);
	}
	
	for (devices_avail=0; devices_avail<DEVICES_MAX; devices_avail++) {
		sock = hci_open_dev( devices_avail );
		if (sock >= 0) {
			close(sock);
			mydevs = add_local_device(mydevs, devices_avail, PURPOSE_PUSH);
			devices_ok++;
		}
	}
	dump_local_devices(mydevs);	

	mycurdev = get_free_local_device(mydevs, PURPOSE_PUSH);
	device = malloc(sizeof(device_t));	
	memset(&push_device,'\0',sizeof(founddevices_t));
	memset(device,'\0',sizeof(device_t));
	
	addr_num = my_str2ba(argv[1]);
	memcpy(&(device->addr),addr_num,sizeof(bdaddr_t));
	device->channel = atoi(argv[2]);
	free(addr_num);
	
	push_device.status = STATUS_READY;
	push_device.d = device;
	
//	obex_push(filename, mime, me, founddevices_t *to)
	obex_push(argv[3], argv[4], mycurdev, &push_device);
	
	return 0;
}
