#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/socket.h>

#include "bluetooth/bluetooth.h"
#include "bluetooth/rfcomm.h"
#include "bluetooth/hci.h"

#define BTADDR "aa:bb:cc:aa:bb:cc"
#define CHANNEL 4

int main(void)
{
int sock;
struct sockaddr_rc laddr, raddr;
struct hci_dev_info di;

if(hci_devinfo(0, &di) < 0)
{
perror("HCI device info failed");
exit(1);
}

laddr.rc_family = AF_BLUETOOTH;
laddr.rc_bdaddr = di.bdaddr;
laddr.rc_channel = 0;

raddr.rc_family = AF_BLUETOOTH;
str2ba(BTADDR,&raddr.rc_bdaddr);
raddr.rc_channel = htobs(CHANNEL);

if(sock = socket(AF_BLUETOOTH, SOCK_STREAM, BTPROTO_RFCOMM) < 0)
{
perror("socket");
exit(1);
}

if(bind(sock, (struct sockaddr *)&laddr, sizeof(laddr)) < 0)
{
perror("bind");
exit(1);
}

if(connect(sock, (struct sockaddr *)&raddr, sizeof(raddr)) < 0)
{
perror("connect");
exit(1);
}

printf("Connected.\n");
close(sock);
return 0;
}
